declare type StateListener<T> = (state: T) => void;
declare type StateSelector<T, U> = (state: T) => U;
declare type PartialState<T> = Partial<T> | ((state: T) => Partial<T>);
export default function create<State extends Record<string, any>, SetState extends (partialState: PartialState<Record<string, any>>) => void, GetState extends () => Record<string, any>>(createState: (set: SetState, get: GetState) => State): [{
    (): State;
    <U>(selector: StateSelector<State, U>, dependencies?: readonly any[] | undefined): U;
}, {
    destroy: () => void;
    getState: () => State;
    setState: (partialState: PartialState<State>) => void;
    subscribe: (listener: StateListener<State>) => () => void;
}];
export {};
